<script setup lang="ts">
import { onMounted } from 'vue'
import WarningDialog from '../components/WarningDialog.vue'
import { useReplenishmentStore } from '../store/replenishment'
import { useInventoryStore } from '../store/inventory'
import { getDateNowString } from '@/utils/constants'
import { useAuthStore } from '@/views/Authentication/stores/auth'
const inventory = useInventoryStore()
const storeRep = useReplenishmentStore()
const auth = useAuthStore()

onMounted(() => {
  storeRep.fetchIngredient()
})
</script>

<template>
  <v-dialog
    v-model="storeRep.isDialogOpen"
    fullscreen
    persistent
    transition="dialog-top-transition"
  >
    <v-card class="px-10 py-2">
      <template #title>
        <v-row>
          <v-col>
            <h3>Replenishment Order</h3>
            <h4>Inventory of branch : {{ inventory.selectedInventory?.branch?.name }}</h4>
          </v-col>
          <v-spacer></v-spacer>
          <v-col>
            <h3>Employee : {{ auth.getCurrentUser()?.email }}</h3>
            <h4>
              {{ `Current date: ${getDateNowString()}` }}
            </h4>
          </v-col>
        </v-row>
        <v-divider class="mt-5" thickness="2"></v-divider>
      </template>
      <v-data-table
        class="px-6"
        :items="storeRep.repItems"
        :headers="storeRep.headers"
        height="500"
        fixed-header
        :items-per-page="0"
        no-data-text="No items"
      >
        <template #item="{ item, index }">
          <tr>
            <td>{{ index + 1 }}</td>
            <td>
              <v-select
                class="d-flex"
                :items="storeRep.availableIngredients"
                :item-title="'name'"
                :item-value="'id'"
                v-model:model-value="item.ingredientId"
                variant="outlined"
              ></v-select>
            </td>
            <td>
              <v-text-field
                name="balance"
                v-model.number="item.balance"
                variant="outlined"
                type="number"
              ></v-text-field>
            </td>
            <td>
              <v-text-field
                name="cost"
                v-model.number="item.cost"
                variant="outlined"
                type="number"
              ></v-text-field>
            </td>
            <td>
              <v-btn variant="plain" icon="mdi-delete" @click="storeRep.removeItem(index)"></v-btn>
            </td>
          </tr>
        </template>
        <template #bottom>
          <v-divider thickness="2"></v-divider>
          <v-row no-gutters class="justify-center mt-3">
            <v-col>
              {{ `Total value : ${storeRep.getTotalCost} ฿` }}
            </v-col>
            <v-col>
              <v-btn text="add" prepend-icon="mdi-plus" variant="tonal" @click="storeRep.addItem()">
              </v-btn>
            </v-col>
          </v-row>
        </template>
      </v-data-table>
      <v-spacer></v-spacer>
      <v-card-actions class="justify-end ma-2">
        <v-btn variant="outlined" @click="storeRep.closeDialog()"> close </v-btn>
        <WarningDialog :save-callback="storeRep.save">
          <template #activator="{ props }">
            <v-btn variant="tonal" v-bind="props"> save </v-btn>
          </template>
        </WarningDialog>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
